/* ------------------------------------------------------------------------ */
/*  Hyper Operating System V4  ITRON4.0 Real-Time OS                  */
/*    ITRONͥ ϥɥ                                          */
/*                                                                          */
/*                                  Copyright (C) 1998-2002 by Project HOS  */
/*                                  http://sourceforge.jp/projects/hos/     */
/* ------------------------------------------------------------------------ */


#include "knl_cyc.h"
#include "knl_mem.h"



/* ϥɥκ */
ER del_cyc(
		ID cycid)	/* оݤμϥɥIDֹ */
{
	T_KERNEL_CYCCB_RAM *cyccb_ram;

	/* ID Υå */
#ifdef HOS_ERCHK_E_ID
	if ( cycid < KERNEL_TMIN_CYCID || cycid > KERNEL_TMAX_CYCID )
	{
		return E_ID;	/* ID */
	}
#endif

	mknl_loc_sys();		/* ƥΥå */

	cyccb_ram = KERNEL_CYCID_TO_CYCCB_RAM(cycid);

	/* ֥¸ߥå */
#ifdef HOS_ERCHK_E_NOEXS
	if ( cyccb_ram == NULL )
	{
		mknl_unl_sys();	/* ƥΥå */
		return E_NOEXS;	/* ֥̤ */
	}
#endif
	
	/* ޥꥹȤ鳰 */
	kernel_rmv_tml((T_KERNEL_TIM *)cyccb_ram);
	
	/* β */
	kernel_fre_mem(cyccb_ram);

	KERNEL_CYCID_TO_CYCCB_RAM(cycid) = NULL;
	
	mknl_unl_sys();		/* ƥΥå */

	return E_OK;
}


/* ------------------------------------------------------------------------ */
/*  Copyright (C) 1998-2002 by Project HOS                                  */
/* ------------------------------------------------------------------------ */
